
#include "Tlc5940.h" //näppärä kirjasto

//Muuttujien nimeäminen
int varisade_tilat[5] = {15,11,13,16,12};//tilat muutakuin 0 ja eri niin alkavat eri aikaan
int varisade_edtilat[5];
int varisade_varit[5];
boolean varisade_tauolla[5];
unsigned long varisade_edellinen_aika[5];

void setup()
{
  Tlc.init();
  Tlc.setAllDC(63);//63
  Tlc.update();
  delay(50);
  Tlc.setAll(4095); //Sammutetaan kaikki
  while(Tlc.update()){;}
  //Serial.begin(9600);//debug
}

void loop(){
  /*
  for(int i=0; i<16; i++){
   aseta(48+i,2000);
   aseta(47+i,0);
   while(Tlc.update()){;}
  delay(1000); 
  }*/
  varisade();
}

//------------------------ "Animaatiot"---------------------------------------------------

//Satunnainen väri, tippuu alaspäin
void varisade(){
  unsigned long time;
  time = millis();
  tilakierto(0,75,time);
  tilakierto(1,75,time);
  tilakierto(2,75,time);
  tilakierto(3,75,time);
  tilakierto(4,751,time);
  
  //Jos tilat eivät ole muuttuneet, ei updatea
  boolean test=false;
  
  for(int i=0; i<5; i++){
    if(varisade_tilat[i] != varisade_edtilat[i]){test=true;}
  }
  
  if(test){
    Tlc.update();
    for(int j=0; j<5; j++){ //tallennetaan edelliset tilat muistiin
     varisade_edtilat[j] = varisade_tilat[j]; 
    }
  }
}

//värisateen tilakierto
void tilakierto(int lokero,int vaihtoviive, unsigned long aika){
  int v; //Väri merkataan tähän
  int taukojen_pituus;
  int teho1 = 4095;
  int teho2 = 2500;
  int teho3 = 1000;
  int teho4 = 200;
  
  //Ensin tarkistetaan onko kyseinen lokero tauolla
  if(varisade_tauolla[lokero]){
    //Tauko päällä, tarkistetaan onko aika kulunut
    if(aika - varisade_edellinen_aika[lokero] >= vaihtoviive){
      varisade_tauolla[lokero] = false;
      varisade_tilat[lokero]++;
      varisade_edellinen_aika[lokero]=aika;
    }
  }
  else{//Jos ei ole tauolla, tehdään tilakierto

    v=varisade_varit[lokero];
    if(varisade_tilat[lokero] >= 16){varisade_tilat[lokero]=0;}//Nollaus

    switch(varisade_tilat[lokero]){
    case 0: //arvotaan uusi väri ja aloitetaan tiputus
      varisade_varit[lokero] = random(0,3);
      v = varisade_varit[lokero]; //apumuuttujaan uusi väri
      varisade_tilat[lokero]++;
      break;
    case 1:
      aseta(lokero*3+0+v,teho1);
      aseta(lokero*3+16+v,0);
      aseta(lokero*3+32+v,0);
      aseta(lokero*3+48+v,0);
      //aseta(lokero*3+64+v,0);
      varisade_tauolla[lokero] = true;
      break;
    case 2:
      aseta(lokero*3+0+v,teho2);
      aseta(lokero*3+16+v,teho1);
      aseta(lokero*3+32+v,0);
      aseta(lokero*3+48+v,0);
      //aseta(lokero*3+64+v,0);
      varisade_tauolla[lokero] = true;
      break;
    case 3:
      aseta(lokero*3+0+v,teho3);
      aseta(lokero*3+16+v,teho2);
      aseta(lokero*3+32+v,teho1);
      aseta(lokero*3+48+v,0);
      //aseta(lokero*3+64+v,0);
      varisade_tauolla[lokero] = true;
      break;
    case 4:
      aseta(lokero*3+0+v,teho4);
      aseta(lokero*3+16+v,teho3);
      aseta(lokero*3+32+v,teho2);
      aseta(lokero*3+48+v,teho1);
      //aseta(lokero*3+64+v,0);
      varisade_tauolla[lokero] = true;
      break;
    case 5:
      aseta(lokero*3+0+v,0);
      aseta(lokero*3+16+v,teho4);
      aseta(lokero*3+32+v,teho3);
      aseta(lokero*3+48+v,teho2);
      //aseta(lokero*3+64+v,teho1);
      varisade_tauolla[lokero] = true;
      break;
    case 6:
      aseta(lokero*3+0+v,0);
      aseta(lokero*3+16+v,0);
      aseta(lokero*3+32+v,teho4);
      aseta(lokero*3+48+v,teho3);
      //aseta(lokero*3+64+v,teho2);
      varisade_tauolla[lokero] = true;
      break;  
    case 7:
      aseta(lokero*3+0+v,0);
      aseta(lokero*3+16+v,0);
      aseta(lokero*3+32+v,0);
      aseta(lokero*3+48+v,teho4);
      //aseta(lokero*3+64+v,teho3);
      varisade_tauolla[lokero] = true;
      break;  
    case 8:
      aseta(lokero*3+0+v,0);
      aseta(lokero*3+16+v,0);
      aseta(lokero*3+32+v,0);
      aseta(lokero*3+48+v,0);
      //aseta(lokero*3+64+v,teho4);
      varisade_tauolla[lokero] = true;
      break;  
    case 9: //Rivi tyhjä
      aseta(lokero*3+0+v,0);
      aseta(lokero*3+16+v,0);
      aseta(lokero*3+32+v,0);
      aseta(lokero*3+48+v,0);
      //aseta(lokero*3+64+v,0);
      varisade_tauolla[lokero] = true;
      break;
    case 10: //valitaan taukojen pituus
      taukojen_pituus = int(random(0,5));
      varisade_tilat[lokero] = 16-taukojen_pituus;
      break;
    case 11: //5. taukoa jäljellä
      varisade_tauolla[lokero] = true;
      break;
    case 12: //4. taukoa jäljellä
      varisade_tauolla[lokero] = true;
      break;
    case 13: //3. taukoa jäljellä
      varisade_tauolla[lokero] = true;
      break;
    case 14: //2. taukoa jäljellä
      varisade_tauolla[lokero] = true;
      break;
    case 15: //Viimeinen tauko -> alkuun
      varisade_tauolla[lokero] = true;
      break;
    }//switch
  }//iffin else
}//tilakierto END


//Hyödylliset funktiot  -------------------------------------------------------------------------------
void aseta(int kanava, int teho){
  Tlc.set(kanava, 4095-teho); 
}
void asetaKaikki(int teho){
  Tlc.setAll(4095-teho);
  while(Tlc.update());
}
  
