
#include "Tlc5940.h" //näppärä kirjasto
#include <EEPROM.h>

//Muuttujien nimeäminen
byte datain[30];//Bufferista luettava data, 2 byteä = yksi lokeron väri
word haluttu_kuva[75]; //Tämä kuva muodostetaan viiveellä
unsigned long ed_aika = 0;
word paivitysviive = 10;
unsigned long aika=0;
int address = 0;
boolean paivitettava=false;


void setup()
{
  Tlc.init(4095);
  Tlc.update();
  delay(100);
  Tlc.setAllDC(63);//63
  Tlc.update();
  delay(50);
  Tlc.setAll(4095); //Sammutetaan kaikki
  while(Tlc.update()){;}
  pinMode(13,OUTPUT);
  Serial.begin(57600);//debug ja sarjaliikenne luku
  
  kuva_eepromilta();// kuvan haku eepromilta DEBUG
}

void loop(){

//---- Sarjaliikenne tarkkailu -----
  if(Serial.available()>29){
   luebytet();
   while(Serial.available()){Serial.read();}
   datasta_varit(0);
   Serial.print("123");
   Serial.flush();
   
   while(Serial.available()<30){;}
   luebytet();
   while(Serial.available()){Serial.read();}
   datasta_varit(1);
   Serial.print("123");
   Serial.flush();
   
   while(Serial.available()<30){;}
   luebytet();
   while(Serial.available()){Serial.read();}
   datasta_varit(2);
   Serial.print("123");
   Serial.flush();
   
   while(Serial.available()<30){;}
   luebytet();
   while(Serial.available()){Serial.read();}
   datasta_varit(3);
   Serial.print("123");
   Serial.flush();

   while(Serial.available()<30){;}
   luebytet();
   while(Serial.available()){Serial.read();}
   datasta_varit(4);
   Serial.print("123");
   Serial.flush();
   
   kuva_eepromille(); //MUUTOS EEPROMIN KÄYTÖN LISÄYS
   //while(Tlc.update()){;}//MUUTOS EEPROMIN KÄYTÖN LISÄYS
  }
//---- Sarjaliikenne tarkkailun loppu -----

//---- Halutun kuvan piirto ja tarkkailu ---- 
// Katsotaan onko oloarvon ja asetusarvon välillä ero,
// jos on, lisätään/otetaan 1 muuttujasta ja päivitetään
aika = millis();

if(aika > ed_aika + paivitysviive){ //Päivitysviiveellä määritellään kuinka nopeasti muutos tapahtuu
 ed_aika = millis();
 
 for(int kerros=0; kerros <5; kerros++){ //DEBUDG
  for(int i=0; i<15; i++){
   siirtyma(kerros, i); 
  } 
 }

 if(paivitettava){ //päivitetään vain jos on muutos
   while(Tlc.update());
   paivitettava = false;
 }
}
//---- Halutun kuvan piirron loppu ---


}

//------------------------ "Animaatiot"---------------------------------------------------



//Hyödylliset funktiot  -------------------------------------------------------------------------------
void aseta(int kanava, int teho){
  Tlc.set(kanava, 4095-teho); 
}
void asetaKaikki(int teho){
  Tlc.setAll(4095-teho);
  while(Tlc.update());
}

void datasta_varit(int lokero){
  
  /* Alkuperäinen, muutettu niin että kirjoitetaan haluttu_kuva muuttujaan tiedot
  for(int j=0; j<15; j++){
    Tlc.set(lokero*16+j, 4095 - (word(datain[j*2+1])<<8 | (word(datain[j*2]))));//word(data[j*2+1])<<8 || word(data[j*2]));
  } 
  */
  for(int j=0; j<15; j++){ //Tässä yhteydessä lokero = kerros...
    haluttu_kuva[lokero*15+j]= (word(datain[j*2+1])<<8 | (word(datain[j*2]))); //4095 - (word(datain[j*2+1])<<8 | (word(datain[j*2])));
  } //haluttu_kuva[lokero*16!!
  
}

void luebytet(){
 for(int i=0; i<30; i++){
  datain[i] = Serial.read();
 }
}

void kuva_eepromilta(){
  address = 0;
  for(int i=0; i<75; i++){ //25 lokeroa, 3 väriä lokerossa
    haluttu_kuva[i] = word(EEPROM.read(address)); //ensimmäinen byte
    address++;
    haluttu_kuva[i] = word(EEPROM.read(address))<<8 | haluttu_kuva[i]; //jälkimmäinen byte
    address++;
  }
}

void kuva_eepromille(){
 address = 0;
 for(int i=0; i<75; i++){
   byte luku=0;
   luku = byte(haluttu_kuva[i] & 255); //ensimmäiset 8 bittiä
   EEPROM.write(address,luku);
   address++;
   luku = byte(haluttu_kuva[i]>>8 & 15); // 9,10,11,12 bitit
   EEPROM.write(address,luku);
   address++;
 } 
}

void siirtyma(int k, int j){
  //k = kerros (0-4), j=väri (0-14)
  int erotus;
  int olo;
  int ind;
  olo = Tlc.get(k*16 + j);
  olo = 4095 - olo;
  ind = (k * 16) - k + j;
  erotus = olo - int(haluttu_kuva[ind]);
  
  if( abs(erotus) < 6){ //kun ollaan 0 tai yhden päässä, ei muuteta)
    //ei tehdä mitään
  }
  else{
    if(erotus > 0){
      //olo=olo-5;
      olo--;
    }
    else{
      //olo=olo+5;
      olo++;
    }
   
   if(olo<0){olo=0;}
   if(olo>4095){olo=4095;}
    
   Tlc.set(k*16+j, 4095 - olo);
   paivitettava = true; // jos tämä on true, tehdään päivitys, muuten ei.
  }
  
}
